package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AreaShowPoint;
import com.izouma.awesomeadmin.service.AreaShowPointService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/areaShowPoint")
public class AreaShowPointController {

    @Autowired
    private AreaShowPointService areaShowPointService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AreaShowPoint record) {
        List<AreaShowPoint> pp = areaShowPointService.getAreaShowPointList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAreaShowPoint", method = RequestMethod.GET)
    @ResponseBody
    public Result getAreaShowPoint(@RequestParam(required = false, value = "id") String id) {
        AreaShowPoint data = areaShowPointService.getAreaShowPointById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AreaShowPoint record) {
        AreaShowPoint data = areaShowPointService.getAreaShowPoint(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AreaShowPoint record) {
        Map<String, Object> result = new HashMap<>();

        List<AreaShowPoint> pp =areaShowPointService.getAreaShowPointByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AreaShowPoint record) {
        boolean num = areaShowPointService.createAreaShowPoint(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAreaShowPoint(AreaShowPoint record) {
        boolean num = areaShowPointService.updateAreaShowPoint(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAreaShowPoint(AreaShowPoint record) {

        boolean num = areaShowPointService.deleteAreaShowPoint(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AreaShowPoint record) throws Exception {

    List<AreaShowPoint> areaShowPoints = areaShowPointService.getAreaShowPointList(record);


        String sheetName = "area_show_point";
        String titleName = "显示点数据表";
        String fileName = "显示点表";
        int columnNumber = 16;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "权限" ,   "城市ID" ,   "地标ID" ,   "区域ID" ,   "名称" ,   "门" ,   "备注" ,   "X" ,   "Y" ,   "index"  };
        String[][] dataList = new String[areaShowPoints.size()][16];

        for (int i = 0; i < areaShowPoints.size(); i++) {

                        dataList[i][0] = String.valueOf(areaShowPoints.get(i).getId());
                        dataList[i][1] = String.valueOf(areaShowPoints.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(areaShowPoints.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(areaShowPoints.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(areaShowPoints.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(areaShowPoints.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(areaShowPoints.get(i).getPower());
                        dataList[i][7] = String.valueOf(areaShowPoints.get(i).getCityId());
                        dataList[i][8] = String.valueOf(areaShowPoints.get(i).getLandmarkId());
                        dataList[i][9] = String.valueOf(areaShowPoints.get(i).getAreaId());
                        dataList[i][10] = String.valueOf(areaShowPoints.get(i).getPointName());
                        dataList[i][11] = String.valueOf(areaShowPoints.get(i).getDoorFlag());
                        dataList[i][12] = String.valueOf(areaShowPoints.get(i).getRemark());
                        dataList[i][13] = String.valueOf(areaShowPoints.get(i).getMapX());
                        dataList[i][14] = String.valueOf(areaShowPoints.get(i).getMapY());
                        dataList[i][15] = String.valueOf(areaShowPoints.get(i).getMapIndex());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

